
#define __ASSEMBLER__

#include	<util/delay.h>
#define FOSC           32000000UL //frequency of oscillator

// IS THERE IS THE DISPLAY ENABLE THS #define DISPLAY_LCD_ENABLED

//ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
//ddelays to be redefined if change oscillator or type of microcontroller
//ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
#define     nS_31    __asm("\tnop")
#define     nS_62    {nS_31;nS_31;}                 
#define     nS_125	 {nS_62;nS_62;}                  //note with 30mhz are 4 nop  
#define     nS_250	 {_delay_us(0.25);} 	         
#define     nS_1625	 {_delay_us(1.7);} 	         

//with32mhz better to use a for loop cycle or _delay_us in delay.h
//#define     nS_500	 {nS_250;nS_250;}               //note with 30mhz are 16 nop
//#define     nS_1625	 {nS_500;nS_500;nS_500;nS_125;} //note with 30mhz are 56 nop... don't use!

//oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
//o DATAFLASH HEAD AREA
//oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo



#define  IMG_START     0        //-1023 indirizzi BITMAPS        256 bitmaps x 4 bytes (2 bytes for page 2 bytes for address)
#define  TXT_ITA_START 1024     //-2047 indirizzi TESTO ITALIANO 256 testi   x 4 bytes (2 bytes for page 2 bytes for address)
#define  TXT_ENG_START 2048     //-3071 indirizzi TESTO INGLESE  256 testi   x 4 bytes (2 bytes for page 2 bytes for address)
#define  TXT_DEU_START 3072     //-4095 indirizzi TESTO TEDESCO  256 testi   x 4 bytes (2 bytes for page 2 bytes for address)
#define  TXT_FRA_START 4096     //-5119 indirizzi TESTO FRANCESE 256 testi   x 4 bytes (2 bytes for page 2 bytes for address)
#define  TXT_SPA_START 5120     //-6143 indirizzi TESTO SPAGNOLO 256 testi   x 4 bytes (2 bytes for page 2 bytes for address)
#define  TXT_HOL_START 6144     //-7167 indirizzi TESTO OLANDESE 256 testi   x 4 bytes (2 bytes for page 2 bytes for address)
#define  AUDIO_START   7168     //-8191 indirizzi MESSAGGI AUDIO 256 suoni   x 4 bytes (2 bytes for page 2 bytes for address)
#define  TXT_NO_LANG   8192     //-9215 TEXT WITHOUT LANGUAGE
#define  FREE_SPACE    9216     //-10239 free
#define  OBJECTS_START 10240    //----- Start to memorize the data for bitmap,text and audio



#define DIMENSION_BMP_AREA  1024 //DIMENSION FOR index for BITMAP AREA = 255 * 4
#define DIMENSION_TXT_AREA  1024 //DIMENSION FOR index of every TEXT AREA for every language = 255 * 4
#define DIMENSION_WAV_AREA  1024 //DIMENSION FOR index of AUDIO WAVE AREA = 255 * 4
#define DIMENSION_F1_AREA   1024 //DIMENSION FOR index of FREE AREA 1 = 255 * 4
#define DIMENSION_F2_AREA   1024 //DIMENSION FOR index of FREE AREA 2 = 255 * 4


//**********************************************************
//!!! ATTENZIONE !!! QUESTI NUMERI SONO DA RIDEFINIRE!!!
//**********************************************************
#define X_RESOLUTION	320//	320
#define Y_RESOLUTION	240
#define MIDPOINT_X		X_RESOLUTION/2
#define MIDPOINT_Y		Y_RESOLUTION/2

//----------------------------------
//---------  TYPE OF MSGBOX  -------
#define WARN	0 //worning
#define INF		1 //info
#define	WAI		2 //wait
#define STO		3 //stop

//-----------------------------------
// ZOOM FOR BITMAP. FOR NOW NOT USED
#define NO_ZOOM	0
#define ZOOM_X2	1
#define ZOOM_X4	2
#define ZOOM_X8	3

//------------------------------
//------   Type of image  ------
#define COLOR_8bit	0	// 8 BIT
#define COLOR_16bit	1	// 16 BIT
#define COLOR_18bit	2	// NOT USED
#define COLOR_24bit	3	// NOT USED

//.-----------------------------
//--------- LCD color ----------
#define WHITE          0xFFFF
#define BLACK          0x0000
#define GREY           0x39ab
#define BLUE           0xA0A2 //0x001F
#define BLUE1          0xF800 //0x001F
#define BLUE2          0xF150 //0x051F
#define RED            0x001F //0xF800
#define MAGENTA        0xF18F //??? NOT RIGHT! 
#define GREEN          0x0E70 //0x07E0
#define CYAN           0xFF81 //0xFFF7 is more light
#define YELLOW         0x5F5F
#define YELLOW2        0x1F1F
#define YELLOW3        0x0eFF //0xFFE0
#define DARK_GREEN     0x4444
#define DARK2_GREEN    0x2222
#define BROWN          0x3333
#define BROWN2         0x1111
#define RED_PINK       0x111F
#define PINK           0xDDDD
#define PINK1          0xBBBB
#define PINK2          0x9999
#define PINK3          0xF15F
#define VIOLET         0xF015
#define VIOLET2        0xF015
#define MYDEMO         0x1F1F
//--------------------------------------
//----- DIMENSION OF THE TEXT ----------
#define PIX_8  0  //8 PIXEL
#define PIX_16 1  //16 PIXEL
#define PIX_24 2  //24 PIXEL
#define PIX_32 3  //32 PIXEL


//--------------------------------------
//  languages definitons
//--------------------------------------
#define ITA      0
#define ENG      1
#define DEU      2
#define FRA      3
#define SPA      4
#define HOL      5

//---------------------------------------
// FOR TOUCH SCREEEN
//---------------------------------------
#define     RIGHT_VALUE         2 //OF FOUR READS i TAKE THE NUMBER 2

//+ooooooooooooooooooooooooooooooooooooooooooooooooooo
//|
//|   General macro definitions
//|
//+ooooooooooooooooooooooooooooooooooooooooooooooooooo
#define  abs_diff(a,b)  ( ( (a)>(b))?((a)-(b)):((b)-(a)) )

#ifndef sbi
	#define sbi(port,bit)	(port |=  (1<<bit))
#else
#endif

#ifndef cbi
	#define cbi(port,bit)	(port &= ~(1<<bit))
#else
#endif
#ifndef in
#define in(port,bit)	(port & (1<<bit))		//(test il bit della porta defnita)
#else
#endif

#define INT_TS_PRESSED		(!(in(INT_TS_port,INT_TS_pin))) //test INT_TS TOUCH SCREEN




//FOR DIGITAL FLASH
//DEFINE THEM LATER

#define DF_CS_inactive	sbi(PORT_CS_AT45,PIN_CS_AT45)			
#define DF_CS_active	cbi(PORT_CS_AT45,PIN_CS_AT45)			
//NOT USED ON xPLAIN   #define DF_RESET        cbi(PORT_RST_AT45,PIN_RST_AT45)
//NOT USED ON xPLAIN   #define DF_NOT_RESET    sbi(PORT_RST_AT45,PIN_RST_AT45)
//NOT USED ON xPLAIN   #define DF_WR_PROTECT   cbi(PORT_WR_PROT_AT45,PIN_WR_PROT_AT45)
//NOT USED ON xPLAIN   #define DF_WR_UNPROTECT sbi(PORT_WR_PROT_AT45,PIN_WR_PROT_AT45)

//OOOOOOOOOOOOOOOOOOOOOO
//O  FOR SD CARD
//OOOOOOOOOOOOOOOOOOOOOO
/*
#define SD_CS_ASSERT     cbi(CS_SD_card_port,CS_SD_card_pin)
#define SD_CS_DEASSERT   sbi(CS_SD_card_port,CS_SD_card_pin)
*/
//ooooooooooooooooooooooooooooooooooo
//o
//o		ERRORS
//o
//ooooooooooooooooooooooooooooooooooo
#define MEMORY_FULL	1

//oooooooooooooooooooooooooooooooooo
//o Defs for VPORTS assembler
//oooooooooooooooooooooooooooooooooo

//ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
//+--------------------------------------------------------------------
//| MY DEFINITIONS FOR TO USE SBI CBI IN and OUT on VIRTUAL PORTS
//+-------------------------------------------------------------------
//oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo

#if defined (__AVR_ATxmega128A1__)
//undefine Virtual port 0
#undef VPORT0_DIR
#undef VPORT0_OUT
#undef VPORT0_IN
#undef VPORT0_INTFLAGS
//undefine Virtual port 1
#undef VPORT1_DIR
#undef VPORT1_OUT
#undef VPORT1_IN
#undef VPORT1_INTFLAGS
//undefine Virtual port 2
#undef VPORT2_DIR
#undef VPORT2_OUT
#undef VPORT2_IN
#undef VPORT2_INTFLAGS
//undefine Virtual port 3
#undef VPORT3_DIR
#undef VPORT3_OUT
#undef VPORT3_IN
#undef VPORT3_INTFLAGS

//redefine VPORTS 
// VPORT0 - Virtual Port 0 
#define VPORT0_DIR _SFR_MEM8(16)
#define VPORT0_OUT _SFR_MEM8(17)
#define VPORT0_IN _SFR_MEM8(18)
#define VPORT0_INTFLAGS _SFR_MEM8(19)

// VPORT1 - Virtual Port 1 
#define VPORT1_DIR _SFR_MEM8(20)
#define VPORT1_OUT _SFR_MEM8(21)
#define VPORT1_IN _SFR_MEM8(22)
#define VPORT1_INTFLAGS _SFR_MEM8(23)

// VPORT2 - Virtual Port 2 
#define VPORT2_DIR _SFR_MEM8(24)
#define VPORT2_OUT _SFR_MEM8(25)
#define VPORT2_IN _SFR_MEM8(26)
#define VPORT2_INTFLAGS _SFR_MEM8(27)

// VPORT3 - Virtual Port 3 
#define VPORT3_DIR _SFR_MEM8(28)
#define VPORT3_OUT _SFR_MEM8(29)
#define VPORT3_IN _SFR_MEM8(30)
#define VPORT3_INTFLAGS _SFR_MEM8(31)


#else
#  if !defined(__COMPILING_AVR_LIBC__)
#    error "Define at the beginning of the file port_driver.h the VPORTx_OUT for the selected device"
#  endif
#endif

//definitions for ports 

//ooooooooooooooooooooo
//o PORTA
//ooooooooooooooooooooo

#define   PA0  0         // OUT LCD     | 
#define   PA1  1         // OUT LCD     |
#define   PA2  2         // OUT LCD     |
#define   PA3  3         // OUT LCD     |
#define   PA4  4         // OUT LCD     |VIRTUAL PORT 1
#define   PA5  5         // OUT LCD     |
#define   PA6  6         // OUT LCD     |
#define   PA7  7         // OUT LCD     |
//ooooooooooooooooooooo      
//o PORTB                  
//ooooooooooooooooooooo        
#define   PB0  0         //INPUT MIC
#define   PB1  1         //WP_SDcard write protect
#define   PB2  2         //DAC0         |
#define   PB3  3         //CS2_AT45 or DAC1 (Chip select for a second dataflash if needed
#define   PB4  5         //TMS (JTAG)   |
#define   PB5  5         //TDI (JTAG)   |
#define   PB6  6         //TCK (JTAG)   |POSSIBLE ADC INPUTS
#define   PB7  7         //TDO (JTAG)   |

//ooooooooooooooooooooo  
//o PORTC                
//ooooooooooooooooooooo  

#define   PC0  0         //RS_lcd               |
#define   PC1  1         //CS_lcd               |  
#define   PC2  2         //WR_lcd               |
#define   PC3  3         //RD_lcd               | 
#define   PC4  4         //RESET_lcd            |VIRTUAL PORT 0
#define   PC5  5         //MOSI    NEW   |SLAVE |
#define   PC6  6         //MISO    NEW   |SPI	|
#define   PC7  7         //SCK     NEW   |      |
//ooooooooooooooooooooo  
//o PORTD                  
//ooooooooooooooooooooo       
#define   PD0  0         //INT_TS (interrupt touchscreen)  |
#define   PD1  1         //CS-SDCARD                       |
#define   PD2  2         //RXD0  |AUX                      |
#define   PD3  3         //TXD0  |UART-D                   |
#define   PD4  4         //CS_TS                           |VIRTUAL PORT 2
#define   PD5  5         //MOSI  |MASTER SPI               |
#define   PD6  6         //MISO  |TS2046                   |
#define   PD7  7         //SCK   |                         | 

//ooooooooooooooooooooo  
//o PORTE                
//ooooooooooooooooooooo  
#define   PE0  0         //WR_AT45  NEW                | sONO I PIN LATERALI
#define   PE1  1         //RST_AT45 NEW                | NOTA  IL PIN 0 E 10 DEL CONNETTORE
#define   PE2  2         //RXD0         |UART-E IRCOM  |
#define   PE3  3         //TXD0         |              |
#define   PE4  4         //CS_AT45  NEW                | VIRTUAL PORT 3
#define   PE5  5         //MOSI         |MASTER SPI    |
#define   PE6  6         //MISO         |DATA FLASH    | 
#define   PE7  7         //SCK          |              |

//ooooooooooooooooooooo  
//o PORTF                
//ooooooooooooooooooooo  
#define   PF0  0         //CTS2  |
#define   PF1  1         //RTS2  |PC COMUNICATION with visual basic
#define   PF2  2         //RXD0  |UART-F     
#define   PF3  3         //TXD0  |
#define   PF4  4         //Presenza SDcard
#define   PF5  5         //MISO  |MASTER SPI
#define   PF6  6         //MOSI  |SD CARD
#define   PF7  7         //SCK   |

//ooooooooooooooooooooo
//o PORTH                FOR SRAM
//ooooooooooooooooooooo
#define   PH0  0         // /WE 
#define   PH1  1         // /RE 
#define   PH2  2         // /ALE1 
#define   PH3  3         // /ALE2 FOR 24 BIT ADDRESS
#define   PH4  4         // /CS0
#define   PH5  5         // /CS1
#define   PH6  6         // /CS2
#define   PH7  7         // /CS3

//ooooooooooooooooooooo
//o PORTJ                FOR SRAM
//ooooooooooooooooooooo
#define   PJ0  0          
#define   PJ1  1         // |  
#define   PJ2  2         // | 
#define   PJ3  3         // | 
#define   PJ4  4         // | DATA FOR SRAM 
#define   PJ5  5         // | 
#define   PJ6  6         // | 
#define   PJ7  7         // | 

//ooooooooooooooooooooo
//o PORTK                FOR SRAM
//ooooooooooooooooooooo
#define   PK0  0         // | 
#define   PK1  1         // | 
#define   PK2  2         // | 
#define   PK3  3         // |  
#define   PK4  4         // | ADDRESS FOR SRAM
#define   PK5  5         // | 
#define   PK6  6         // | 
#define   PK7  7         // | 

//ooooooooooooooooooooo
//o PORTQ
//ooooooooooooooooooooo
#define   PQ0  0         //SW1
#define   PQ1  1         //SW2
#define   PQ2  2         //SW3
#define   PQ3  3         //CS_SDRAM EXTERNAL

//ooooooooooooooooooooo
//o PORTR
//ooooooooooooooooooooo
//#define   PDI_DATA     //
//#define   PDI_CLOCK    //
#define     PR0  0       // XTAL1
#define     PR1  1       // XTAL2

/*
NOTE:
1- se si usa la porta PDI ricordarsi di togliere la R=100k e la capaci sul Reset perch 
   la usa la PDI come PDI_CLOCK
2- Ricordati di mettere giuste le capaci sui chipselect delle varie periferiche come LCD, Dataflash, SD card ecc
3- Prevedere il translatore di livello sulla SPI slave usata come ingresso per domunicare con una potenza
*/


