/* This file has been prepared for Doxygen automatic documentation generation.*/
/*! \file *********************************************************************
 *
 * \brief  XMEGA main color LCD
 *
 *      This file contains initializations of the ports, vport definitions and
 *      initializations of all devices
 *
 * \par First release
 *
 *
 * \par Documentation
 *      For comprehensive code documentation, supported compilers, compiler
 *      settings and supported devices see readme.html
 *
 * \author
 *      silfradent: http://www.silfradent.com \n
 *
 *
 * $Revision: 0001 $
 * $Date: 2008-12-13 $  \n
 *
 * Copyright (c) 2008, silfradent Corporation All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, NOT are permitted provided that the following conditions are met:
 *
 *****************************************************************************/


#include "main.h"



//void My_Example3( void );

//ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
//-------------------------------------------------------------------
// MAIN 
//--------------------------------------------------------------------
//oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
uint8_t byte_audio = 0;

int main( void )
{

//	uint8_t a = 0;

		//oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
		/*  Enable internal 32 MHz ring oscillator and wait until it's
		 *  stable. Divide clock by two with the prescaler C and set the
		 *  32 MHz ring oscillator as the main clock source. Wait for
		 *  user input while the LEDs toggle.
		 */
		 //ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
		CLKSYS_Enable( OSC_RC32MEN_bm );
		CLKSYS_Prescalers_Config( CLK_PSADIV_1_gc, CLK_PSBCDIV_1_1_gc );
		do {} while ( CLKSYS_IsReady( OSC_RC32MRDY_bm ) == 0 );
		CLKSYS_Main_ClockSource_Select( CLK_SCLKSEL_RC32M_gc );
        

        //ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
		//initialize the ports I/O and special functions
		//ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
		Init_Ports();       //init microcontroller ports

//doesn't work well at 32Mhz change the parameters
  //   Initialize_EBI(); //initialize the EBI for to use the SDRAM

		//ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
		// Enable HIGH level interrupts in the interrupt controller.
		//ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
		PMIC.CTRL |= PMIC_MEDLVLEN_bm | PMIC_LOLVLEN_bm; //PMIC_HILVLEN_bm;
		sei();
//oooooooooooooooooooooooooooo
//used for demo
//oooooooooooooooooooooooooooo
		//downloAD FROM PC
    PORTE.OUTCLR = (1<<0);

	while(true)
	{
	    _delay_ms(1000);

        stop_bit = 1;  
        flagbutton = 0;
    	Audio_Play();
     

	}
}


